#!/bin/sh
if [ "x$1" == "x" -o "x$2" == "x" ]; then
  echo Usage: $0 cvsnt-branch wm-branch
  exit -1
fi

BRANCH=$1
PATH=/cygdrive/d/cvsbin:${PATH}:/cygdrive/c/"program files"/winzip:/cygdrive/c/"Program Files"/PuTTY:/cygdrive/c/"Program Files"/"HTML Help Workshop":/cygdrive/d/cvsbin/keep
rm -rf cvsnt
INCLUDE="/cvsdeps/openssl/include;/cvsdeps/iconv/include"
LIB="/cvsdeps/openssl/lib;/cvsdeps/iconv/lib"
TOP="`pwd`"
if [ ! -x /cygdrive/d/cvsbin/cvs.exe ]; then
  echo CVS.EXE has not been successfully installed - cannot continue
  read
  exit 1
fi

if [ "x$1" != "xCVSNT_2_0_x" -a "x$1" != "xTrunk" ]; then
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r CVSNT_2_0_x cvsnt/plink
  rm -rf cvsnt/plink/plink.vcproj cvsnt/plink/plink.sln
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/plink/plink.vcproj cvsnt/plink/plink.sln
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/postinst cvsnt/protocols cvsnt/pwgen cvsnt/rcs cvsnt/redhat cvsnt/run_script
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/scandir cvsnt/simcvs cvsnt/sles cvsnt/solaris cvsnt/src cvsnt/su cvsnt/suidtest
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/suse 
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/testcvs "cvsnt/tonys scripts" cvsnt/tools cvsnt/triggers
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/ufc-crypt cvsnt/unicodeapi cvsnt/uninsthlp cvsnt/wincvs
  cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt/windows-NT cvsnt/xdiff cvsnt/xmlapi cvsnt/zlib
fi
cvs -d :pserver:abarrett@cvs.cvsnt.org:/usr/local/cvs co -r $BRANCH cvsnt
cd cvsnt
rm -rf winrel
mkdir winrel
#if [ -f /cygdrive/d/cvsbin/mkmanifest.exe ]; then
#  cp /cygdrive/d/cvsbin/mkmanifest.exe winrel
#  ls -la winrel/mkmanifest.exe
#fi
devenv.com /rebuild release cvsnt.sln
cp /cygdrive/d/cvsbin/sysfiles/iconv.dll winrel
ls -la winrel/iconv.dll
if [ ! -x winrel/cvs.exe ]; then
  echo CVS.EXE has not been successfully built - cannot continue
  read
  exit 1
fi
echo "About to sign"
echo "signcode is in C:\\Program Files (x86)\\Microsoft Visual Studio .NET 2003\\SDK\\v1.1\\Bin"
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvs.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvs95.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/co.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvsagent.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvscontrol.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvsdiag.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvslock.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvsservice.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/extnt.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/postinst.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/rcsdiff.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/rlog.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/setci.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/simcvs.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/su.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/uninsthlp.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/WorkspaceViewer.exe
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvsapi.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/cvstools.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/mdnsclient.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/plink.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/setuid.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/triggers/audit.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/triggers/checkout.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/triggers/email.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/triggers/info.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/triggers/script.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/enum.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/ext.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/fork.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/gserver.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/pserver.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/server.dll	
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/sserver.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/ssh.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/protocols/sspi.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/xdiff/extdiff.dll
signcode -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winrel/xdiff/xmldiff.dll
echo Signing complete

winrel/cvs.exe ver -q
BUILD=`winrel/cvs.exe ver -q`
echo Build=$BUILD
echo $BUILD >doc/version.inc
cat doc/version.inc
if [ "x$BUILD" == "x" ]; then
  echo CVSNT cannot give a version number - it is bad
  exit -1
fi
TAG=CVSNT_`echo $BUILD | sed 's/\./_/g'`
echo Tag=$TAG
perl.exe /cvsdeps/cvs2cl/cvs2cl.pl -F $BRANCH --window 3600
cvs -q commit -m "Build $BUILD"
winrel/cvs.exe tag -F $TAG
cd "$TOP"
rm -f ../*
if [ -f ../cvsapi.dll ]; then
  echo Cannot build due to locked files!
  read
  exit 1
fi
export TARGET=/cygdrive/d/cvsbin
export TARGET_WIN32=d:/cvsbin
export BASE="`pwd`/cvsnt"
export TYPE=winrel
ls -la cvsnt/tonys\ scripts/copy_common.sh
sh cvsnt/tonys\ scripts/copy_common.sh
cd cvsnt/doc
ls -la ./build.bat ./pdk.cfg
pwd
./build.bat cvs
ls -la ./*.chm
ls -la ./build-pdk.bat
pwd
echo ./build-pdk.bat $BUILD
./build-pdk.bat $BUILD
ls -la ./*.chm

cd /cygdrive/d/march-hare
rm -rf WorkspaceManager releasemanager vs.net wincvs winmerge tortoisecvs triggers build cvsflt2 
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 WorkspaceManager
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 vs.net
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 vs.net/res3
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 vs.net/scccfg
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 triggers
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co -r $2 build
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co releasemanager
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co wincvs
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll wincvs/wincvs.exe
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co winmerge
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winmerge/WinMerge.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winmerge/WinMergeU.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winmerge/ShellExtension.dll
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll winmerge/ShellExtensionU.dll
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co tortoisecvs
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/TortoiseAct.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/TortoisePlink.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/TortoiseSetupHelper.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/puttygen.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/TortoiseSpawn.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll tortoisecvs/TrtseShl.dll
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co cvsflt2
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co eBook
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs co customer-docs

cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs ci -m "signed by release_builder.sh" wincvs winmerge tortoisecvs

cd /cygdrive/d/march-hare/build
devenv.com /rebuild release build.sln
if [ ! -x /cygdrive/d/march-hare/binRelease/triggers/bugzilla.dll ]; then
  echo bugzilla.dll  has not been successfully built - cannot continue
  read
  exit 1
fi
if [ ! -x /cygdrive/d/march-hare/binRelease/triggers/make.dll ]; then
  echo make.dll  has not been successfully built - cannot continue
  read
  exit 1
fi
if [ ! -x /cygdrive/d/march-hare/binRelease/cvsscci.dll ]; then
  echo cvsscci.dll has not been successfully built - cannot continue
  read
  exit 1
fi
if [ ! -x /cygdrive/d/march-hare/binRelease/ReleaseManager.exe ]; then
  echo ReleaseManager.exe has not been successfully built - cannot continue
  read
  exit 1
fi
if [ ! -x /cygdrive/d/march-hare/binRelease/scccfg.exe ]; then
  echo scccfg.exe has not been successfully built - cannot continue
  read
  exit 1
fi
if [ ! -x /cygdrive/d/march-hare/binRelease/WorkspaceManager.exe ]; then
  echo WorkspaceManager.exe has not been successfully built - cannot continue
  read
  exit 1
fi


cd /cygdrive/d/march-hare
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/WorkspaceManager.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/scccfg.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/cvsscci.dll
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/ReleaseManager.exe
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/triggers/bugzilla.dll
signcode -n "CVS Suite" -i "http://march-hare.com/cvsnt/" -a sha1 -cn "March Hare Software Ltd" -t http://timestamp.verisign.com/scripts/timestamp.dll binRelease/triggers/make.dll
cp binRelease/scccfg.exe tortoisecvs
cp binRelease/cvsscci.dll tortoisecvs
cvs -d :pserver:abarrett@scotty-3.local.nodomain.org:/cvs ci -m "signed by release_builder.sh" tortoisecvs

cvs.exe tag -F $TAG

cd "$TOP"
cp cvsnt/doc/*.chm ..
cp cvsnt/WinRel/*.pdb ../pdb
cp cvsnt/WinRel/protocols/*.pdb ../pdb/protocols
cp cvsnt/WinRel/triggers/*.pdb ../pdb/triggers
cp cvsnt/WinRel/xdiff/*.pdb ../pdb/xdiff
cd cvsnt/installer
nmake
mv cvsnt-${BUILD}.msi ../../..
if [ "x$1" == "xCVSNT_2_0_x" -o "x$1" == "xHEAD" ]; then
  mv cvsnt-server-${BUILD}.msi ../../..
fi
./makeu3.bat ${BUILD}
mv cvsagent-${BUILD}.u3p ../../..
cd ../../..
wzzip -P cvsnt-${BUILD}-bin.zip *.dll *.exe *.cpl *.ini ca.pem infolib.h COPYING triggers protocols xdiff
wzzip -pr cvsnt-${BUILD}-pdb.zip pdb
wzzip -Pr cvsnt-${BUILD}-dev.zip cvsnt-pdk.chm inc lib
cp keep/*.* .
echo ${BUILD} >release
if [ "x$1" == "CVSNT_2_0_x" -o "x$1" == "HEAD" ]; then
  pscp -i d:/arthur.ppk cvsnt-server-${BUILD}.msi release abarrett@acer64debian:/home/abarrett/cvs
fi
pscp -i d:/arthur.ppk *.zip cvsnt-${BUILD}.msi *.u3p cvs.chm release abarrett@acer64debian:/home/abarrett/cvs
